//+------------------------------------------------------------------+
//|                                                 .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property copyright "Sergey Golikov"
/*
       01.01.2009  01.03.2009   ."".
-   01.03.2009  17.07.2009 . .
  ,       : 57.6% , 13.6%  , 11.9% 
, 9.1%  , 4.2%  , 3.6%  . **   :     0.00 
*/
//+------------------------------------------------------------------+
#define MB 11111
#define MS 22222
//+------------------------------------------------------------------+
extern string y="EURUSD"; 

extern string y1             ="  ";
extern int ON_SL             =1;//  0   
//extern int Sl                =50;
extern double n              =0.91;// -    .        
                                  //    %        .
                                  //        .      //extern int Sl =50;,
                                  //     -.          .
                                  //     ,         .    
                                  //   (  )     .   n  2   0.1.
extern string y2             ="  ";
extern int ON_TP             =1;// 0   
extern int Profit            =302;

extern string y3            =" ";
extern double Lots          =0.1;
extern double K_0           =2;//2    
extern double K             =2;//2   
extern double MaxLot        =6.4;
extern int Losse            =1;//-      

extern string y4            ="    ";
extern bool LotsSize        =false;
extern double MaximumRisk   =0.01;

extern string y5           ="  ";
extern bool TS             =false;
extern int Sl_TS           =272;
extern int TrailingStep    =126;

extern string y6           = "   ";
extern int PeriodPower     =15;
extern int Period_Bulls    =10;
extern int Period_Bears    =14;
extern double _UP   =0.05;//     
extern double _DN   =0.15;//     
extern int                = 870;//          .   Delta = (MA_Bears + MA_Bulls)
                                 //           Delta     -.    
                                 //  10  1000   10 


extern string  y7           ="      ";
extern int Delta2           =794;//           ( )  .
extern int Delta1           =1128;//           ( )  .
extern int Razmax           =1250;//   .  .       .

extern string  y8            =  "   ";
extern int       StartHour   = 0;//         
extern int       EndHour     = 14;//         .
                                 //       
extern int       StopHour    = 24;//    .        .
extern int PeriodMA=40;  
#include <stdlib.mqh>
#include <stderror.mqh>  

//=======================================================================================================


double LotsOptimized()
{
   double x=Losse;
   double lot=Lots;
   int    orders=HistoryTotal();     
   int    losses=0; 
   int    Pair ;               
//=====================        ================
  {
   if(LotsSize)
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,2);
  }
//==================     ,    ==========
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
 //==========================     ,     ==============
        
      if(losses>((x)-1)) lot=NormalizeDouble(lot*K_0,2);//     _0,_1,......._100 ,        
      if(losses>((x*2)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*3)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*4)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*5)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*6)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*7)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*8)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*9)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*10)-1)) lot=NormalizeDouble(lot*K,2);
      if(losses>((x*11)-1)) lot=NormalizeDouble(lot*K,2);
     }
    
 //----------------------------------------------------------------------+
 //                    +
 //         +
 //     Vinin.   .                         +
 //         .                     +
 //----------------------------------------------------------------------+
 //==========================     ,     ==============
 /*
      if(losses>((x)-1)) lot=NormalizeDouble(lot*K_0,2);
      for(int k=2;k<=11;k++)
         if(losses>((x*k)-1)) 
            lot=NormalizeDouble(lot*K,2);
   }
    
 */    
//===========================   ===============================================
/*
 double minlot=MarketInfo(Pair,MODE_MINLOT);
 double maxlot=MarketInfo(Pair,MODE_MAXLOT);   
 lot=MathMax(maxlot,MathMin(minlot,lot));
*/
   if(lot<0.1) lot=0.1;
   if(lot>MaxLot) lot=MaxLot;
   return(lot);

}

int start()
{
  
   LotsOptimized();
   Open__();
   if(TS) TradingStop();
   return(0);
}
//================================================================================================================

int i,buy,sell,Pair,Trend/* ,Razmax */;
int Open__()
{
 buy=0;sell=0;
 for(int  i=0;i<OrdersTotal();i++)
                 {
                   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                   if(OrderType()==OP_BUY ){buy=1;}
                   if(OrderType()==OP_SELL){sell=1;}
                 }          
//==========================================       ==================  
//        MorninFlat_Expert.mq4   Scriptong.   .   =
//==================================================================================================================                                                                                   
 {
  datetime BeginDay = iTime(Pair, PERIOD_D1, 0);  //    
  double StartBar   = iBarShift(Pair, PERIOD_H1, BeginDay+StartHour*3600);   // ,       
  double FinishBar  = iBarShift(Pair, PERIOD_H1, BeginDay+(EndHour-1)*3600); // ,    " "
  double LowV       = iLow(Pair, PERIOD_H1, iLowest(Pair, PERIOD_H1, MODE_LOW, StartBar-FinishBar+1, FinishBar));  //  
  double HighV      = iHigh(Pair, PERIOD_H1, iHighest(Pair, PERIOD_H1, MODE_HIGH, StartBar-FinishBar+1, FinishBar)); //  
  double Target     = (HighV-LowV)/Point;
 }  
  int HourCurrent=TimeHour(TimeCurrent());

//Razmax =(iMA(NULL, PERIOD_D1,PeriodMA , 0, MODE_EMA, PRICE_HIGH, 1)/Point)-(iMA(NULL, PERIOD_D1,PeriodMA , 0, MODE_EMA, PRICE_LOW, 1)/Point);   
//==================================   ============================================================ 
//          533.   .                     =
//===================================================================================================================    
     double Bears_array[50]; int cx=0; while (cx<51)
     {Bears_array[cx]= iBearsPower(NULL, 0, PeriodPower,PRICE_CLOSE,cx); cx++; }
     ArraySetAsSeries(Bears_array,true);
     double MA_Bears =iMAOnArray(Bears_array,0,Period_Bears,1,MODE_SMMA,0); 

     double Bulls_array[50]; int lx=0; while (lx<51)
     {Bulls_array[lx]= iBullsPower(NULL, 0, PeriodPower,PRICE_CLOSE,lx); lx++; } 
     ArraySetAsSeries(Bulls_array,true);
     double MA_Bulls =iMAOnArray(Bulls_array,0,Period_Bulls,1,MODE_SMMA,0); 

     double Delta = (MA_Bears + MA_Bulls)*;
//=============================================     ===========================  
//       Vinin.   .  
//===================================================================================================================      
     double Price_00=iOpen(NULL,PERIOD_D1,0); //   
     double Price_Cur=Close[0];               //  

      double Sl = n*Profit;                //   ,  ,-   .
                                             //       (        )
                                             //        .
//=============================================   ========================================

 //if  (((Price_Cur-Price_00)/Point)>Delta1  && buy==0 && sell==0) //             
 
 // if  ((Delta+_DN) < 0&&((Price_Cur-Price_00)/Point)>Delta1 &&  buy==0  && sell==0  ) //        

 //if  (((Price_Cur-Price_00)/Point)>Delta1  &&sell==0 && buy==0 && Target>Razmax ) //           
 
 // if ((( Price_00-Price_Cur)/Point)>Delta1 && buy==0 && sell==0 && Target>Razmax && HourCurrent>=EndHour && HourCurrent<StopHour)//       

if ((Delta+_DN) < 0&&(( Price_00-Price_Cur)/Point)>Delta1 && buy==0 && sell==0 && Target>Razmax && HourCurrent>=EndHour && HourCurrent<StopHour)//         

      {
       RefreshRates();
       OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,
       (Bid-Sl*Point)*ON_SL,
       (Ask+Profit*Point)*ON_TP,"",MB,0,Red);
      }
//===========================   =========================================================== 
 
// if ((( Price_00-Price_Cur)/Point)>Delta2 && sell==0 && buy==0  )//            
 
 // if ( (Delta-_UP) > 0 &&(( Price_00-Price_Cur)/Point)>Delta2 && sell==0  &&  buy==0)  //                
 
 // if ((( Price_00-Price_Cur)/Point)>Delta2 &&buy==0 && sell==0 && Target>Razmax )//             
    
 //  if  (((Price_Cur-Price_00)/Point)>Delta2  && sell==0  && buy==0 && Target>Razmax && HourCurrent>=EndHour && HourCurrent<StopHour)//       
     
  if  ((Delta-_UP) > 0 &&((Price_Cur-Price_00)/Point)>Delta2  && sell==0  && buy==0 && Target>Razmax && HourCurrent>=EndHour && HourCurrent<StopHour)//                         
      {
       RefreshRates();
       OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,
       (Ask+Sl*Point)*ON_SL,
       (Bid-Profit*Point)*ON_TP,"",MS,0,Red);
      }
}                 
   
//======================================== ===============================================================
 
int i1,buy1,sell1;
int TradingStop()
{                
buy1=0;sell1=0;  
for(int  i1=0;i1<OrdersTotal();i1++)
                 {
                   OrderSelect(i1, SELECT_BY_POS, MODE_TRADES);
                   if(OrderType()==OP_BUY ){buy1=1;}
                   if(OrderType()==OP_SELL){sell1=1;}
                 }  
if(buy1==1)  
                 {                 
                   if(Bid - OrderOpenPrice() > Point*TrailingStep)
                     {
                       if(OrderStopLoss() < Bid - Point*TrailingStep)
                         {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Bid - Point*Sl_TS,
                                       OrderTakeProfit(), 0, Green);
                           return(0);
                         }
                     }
                 }
if(sell1==1)  
                 {                 
                   if((OrderOpenPrice() - Ask) > Point*TrailingStep)
                     {
                       if(OrderStopLoss() > Ask+Point*TrailingStep)
                       
                         {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Ask + Point*Sl_TS,
                                       OrderTakeProfit(), 0, Red);
                           return(0);
                         }
                     }
                 }
}






